--- common/dhcp2radius.c.orig	2011-08-11 17:43:40.000000000 +0700
+++ common/dhcp2radius.c	2011-08-11 17:57:06.000000000 +0700
@@ -74,6 +74,9 @@
 													клиентом адреса. Инициализируется в случае использования 
 													опции radius-send-opts-to-srv */
 
+int dispatch_dhcp_packet(struct dhcp_packet *, unsigned *, struct interface_info *,
+	struct hardware *, uint8_t *, RAD_MESSAGE *);
+
 isc_result_t got_radius_packet(uint8_t * raw_packet, uint32_t length)
 {
 	RAD_MESSAGE auth_pack;
@@ -174,7 +177,7 @@
 	uint8_t from_cache = 0;
 	struct interface_info * out = 0;	/* Указатель определяющий выходной интерфейс для отправляемого пакета */
 	struct sockaddr_in to;				/* IP информация о хосте назначения пакета */
-	struct hardware hto, *htop;			/* Физический адрес хоста назначения */
+	struct hardware hto, *htop = NULL;		/* Физический адрес хоста назначения */
 
 	int ret = 0;
 
@@ -839,7 +842,7 @@
 		auth_union.digits[i] = random(); /* Генерируем случайный идентификатор RADIUS запроса */
     memcpy(access_req->header.auth, auth_union.auth, MD5_LEN);
 
-	ret = encrypt_passwd(passwd, encr_passwd, rad_secret, auth_union.auth);
+	ret = encrypt_passwd(passwd, encr_passwd, (char*)rad_secret, auth_union.auth);
 	if(ret != ENCR_PWD_LEN)
     {
         log_error ("PATCH: error - encrypt_passwd() failed. Return value %d . Exiting from assemble_auth_message()!", ret);
@@ -1393,7 +1396,7 @@
 	Функция устанавливающая тип DHCP сообщения в исходящем пакете клиенту.
 */
 uint8_t set_dhcp_type_of_out_packet(struct dhcp_packet * out_packet, const int out_pack_len, 
-								XID_NODE * cur_xid, const server_id)
+								XID_NODE * cur_xid, const int server_id)
 {
 	uint8_t out_packet_type = DHCPACK;
     /* Выбираем тип сообщения который будет отправлен в DHCP пакете к клиенту */
@@ -1707,7 +1710,7 @@
 			while(xid)
 			{
 				if(xid -> req_header.id == rad_ptr -> header.id &&
-					calc_reply_auth(rad_ptr, xid -> req_header.auth, rad_secret) == 0)
+					calc_reply_auth(rad_ptr, xid -> req_header.auth, (char*)rad_secret) == 0)
 				{
 					static struct in_addr ip;
 					static char srv_addr[16];
@@ -1750,7 +1753,7 @@
         return 0;
     }
 
-    if(calc_reply_auth(rad_ptr, xid -> req_header.auth, rad_secret) != 0)
+    if(calc_reply_auth(rad_ptr, xid -> req_header.auth, (char*)rad_secret) != 0)
     {
         log_info ("WARN: Invalid autentificator in RADIUS. BOOTREPLY aborted.");   
         return 0;
@@ -1919,14 +1922,14 @@
         xid_ptr = add_xid(packet, dhcp_type, ip -> primary_address.s_addr, hw_from);
         uint8_t mac_addr[STR_MAC_ADDR_LEN];
         bzero(mac_addr, sizeof(mac_addr));
-        sprintf(mac_addr, 
+        sprintf((char*)mac_addr, 
 				(radius_use_mac_delim)? 
 					"%02x:%02x:%02x:%02x:%02x:%02x" :
 					"%02x%02x%02x%02x%02x%02x", 
                 packet -> chaddr[0], packet -> chaddr[1], packet -> chaddr[2], 
                 packet -> chaddr[3], packet -> chaddr[4], packet -> chaddr[5]);
         *length = assemble_auth_message(auth_pack, packet, *length,
-											mac_addr, rad_users_passwd, 
+									(char*)mac_addr, (char*)rad_users_passwd, 
 											packet -> giaddr.s_addr ? 
 												packet -> giaddr.s_addr :
                                                 ip -> primary_address.s_addr);
